import numpy as np

def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        pass
 
    try:
        import unicodedata
        unicodedata.numeric(s)
        return True
    except (TypeError, ValueError):
        pass
 
    return False



def make_dict_entries (entrL):
    """
    I don't understand what happens below
    """
    dd = {}
    for entr in entrL:
        key, svals = entr.split(':')

        #first look w/r svals is an array
        isdigit = is_number(svals)
        if svals[:3]=='af[':
            out = np.float64(np.array( svals[3:-1].split(',') ))

        #binary
        elif svals.strip()=='False':
            out = False
        elif svals.strip()=='True':
            out = True

        elif isdigit:
            out = np.float64(svals)

        #a string/
        else:
            out = svals

        dd[key.strip()] = out
    return dd


def readhdr_myTable (fname, scolh='cols',sparkey='#pars',scolval='colval',
                     srowid='row-id', sparfmtkey='#fmtpars', doFormatPars=True):
    """
    returns the table hdr information, which is detailed in the comments in the
    main line of the file. The format used is:

    #cols::[scol1,scol2,..]
    #colunits::[unitcol1,unitcol2,..]
    #pars::[sa,sb,...]:: a b ...
    #row-id::[0:srow1,1:srow2...]
    (no spaces between strings)

    for the column headers a list of strings is returned
    and a dictionary of the parameters is returned

    versions:
        [17.01.25]  :added support for units
        [17.07.19]  :added hash and colons for default arg for "sparkey"
                     added option 'doFormatPars' which will convert strings to floats or ints 
                        (but not bools)
        [18.04.15]  :added support for arrays in column header entries;
                    :should be formatted as [..,{4name},..]
    """
    f = open(fname,'r')
    line = f.readline()
    scuL = []
    shdr = []
    srowhdr = []
    dpar = {}
    while line[0]=='#':
        if line.count(scolh):
          a1 = line.split('::')
          a2 = (a1[1]).strip()
          a3 = a2[1:len(a2)-1]#removes the brackets
          sdum = a3.split(',')
          for sd in sdum:
              if sd[0]!='{':
                  shdr.append(sd)
              else:#an array!
                  Nrep = int(sd[1])
                  sval = sd[2:-1]
                  for i in range(Nrep): shdr.append(sval)
        elif line.count('colunits'):
          a1 = line.split('::')
          a2 = (a1[1]).strip()
          a3 = a2[1:len(a2)-1]#removes the brackets
          scuL = a3.split(',')
        elif line.count(srowid):
          a1 = line.split('::')
          a2 = (a1[1]).strip()
          a3 = a2[1:len(a2)-1]#removes the brackets
          a4 = a3.split(',')
          for sub in a4:
            ix = sub.index(':')
            srowhdr.append(sub[ix+1:])
        elif line.count(sparkey):
            if doFormatPars:
                a1 = line.split('::')
                dparkeyL = (a1[1][1:len(a1[1])-1]).split(',') #the keys
                dparvalL = (a1[2]).strip().split() #the values
                #..now we wait for reading the format key line
                for k in range(len(dparvalL)):
                    sdum =dparvalL[k]
                    if sdum.isdigit():#it's a pure number; assume int
                        val = int(sdum)
                    else:
                        if sdum.count('.'):#it's a float
                            val = float(sdum)
                        elif sdum=='False': val = False
                        elif sdum=='True': val = True
                        else:#a string
                            val = sdum

                    dpar[dparkeyL[k]] = val
            else:
                a1 = line.split('::')
                a2 = (a1[2]).strip()
                a3 = a1[1]
                a4 = a3[1:len(a3)-1]#removes the brackets
                xpar = a4.split(',')
                xval = a2.split()
                if a3.count('['):#alist
                  Npar = len(xpar)
                  for k in range(Npar):
                    dpar[xpar[k]] = xval[k]
                elif a3.count('{'):#an array
                  dpar[xpar[0]] = float64(xval)
        elif line.count(scolval):
          a1 = line.split('::')
          colname = a1[1]
          a2 = a1[2].split()
          colvals = float64(a2)
          dpar[colname] = colvals

        line = f.readline()
        if not line: break#end of line reached


    out = []
    if srowhdr==[] and shdr==[] and dpar=={}:
        print(dpar)
        print('[pythonpros.readhdr_myTable]Error: No header found')
        sys.exit()
    if shdr!=[]:
        out.append(shdr)
    if scuL!=[]:
        out.append(scuL)
    if dpar!={}:
        out.append(dpar)
    if srowhdr!=[]:
        out.append(srowhdr)

    if len(out)==1:
        return out[0]
    else:
        return out
