import subprocess as sp
import numpy as np
import time
import sys
sys.path.append('./../Genfuns/')
import utilities as util

#clear entries in runs
proc = sp.call(['mkdir', 'Runs'])
proc = sp.Popen('rm Runs/*', shell=True, stdout=sp.PIPE, stderr=sp.PIPE)

python_command = sys.executable

fname = sys.argv[1]
scolL, dpars = util.readhdr_myTable(fname)
data = np.loadtxt(fname, dtype=str)
if len(data.shape)==1:
    data = np.array([data])

argL0 = []
for key in dpars.keys():
    argL0.append(key+':'+dpars[key])

Nrow, Ncol = data.shape

t0 = time.time()
runtimeL = []
for i in range(Nrow):
    argL = [scolL[k]+':'+data[i,k] for k in range(Ncol)]
    
    sp.call(['time', python_command, 'cloud-model.py']+argL0+argL)

    t1 = time.time()
    print('[runmodels.py]:line i/N done', i+1, '/', Nrow)
    print('[runmodels.py]:elapsed time',  t1-t0, 'sec')
    runtimeL.append(t1-t0)

    t0 = t1
    sp.call(['cp', 'output.dat', 'Runs/'+'{:03d}'.format(i)+'.dat'])

sp.call(['cp', fname, 'Runs/'])
print(np.array(runtimeL).min(), np.array(runtimeL).mean(), np.array(runtimeL).max(), np.array(runtimeL).sum())
print(np.array(runtimeL))
